1 REM DECLARATIONS
2 LET SLOT = -1 : REM SLOT OF THE ESP32 SOFTCARD
3 LET ADDR = 0 : REM ADDRESS OF THE SOFTCARD CARD
4 LET P0ARD = 0 : REM PORT0 ADDRESS TO SEND DATA
5 LET P1ARD = 0 : REM PORT1 ADDRESS TO RECEIVE DATA
6 LET VAPPLE = 84 : REM APPLE VIDEO ON - ALSO USED TO FIND THE ESP32 SOFTCARD
7 LET VESP32 = 85 : REM APPLE VIDEO OFF - ALSO USED TO FIND THE ESP32 SOFTCARD
8 LET VID = 0 : REM CURRENT VIDEO MODE, CAN BE EITHER VAPPLE OR VESP32
9 LET CANEXIT = 0 : REM WHEN THIS BECOMES TRUE, THE PROGRAM CAN EXIT
10 LET KB = ASC("K") : REM KEYBOARD BYTE
11 LET JX = ASC("X") : REM JOYSTICK X BYTE
12 LET JY = ASC("Y") : REM JOYSTICK Y BYTE
13 LET B1 = ASC("1") : REM JOYSTICK BUTTON 1 BYTE
14 LET B2 = ASC("2") : REM JOYSTICK BUTTON 2 BYTE
15 LET XLAST = 0 : REM PREVIOUS X POSITION OF JOYSTICK
16 LET YLAST = 0 : REM PREVIOUS Y POSITION OF JOYSTICK
17 LET XCURRENT = 0 : REM CURRENT X POSITION OF JOYSTICK
18 LET YCURRENT = 0 : REM CURRENT Y POSITION OF JOYSTICK
19 LET L1 = 0 : REM PREVIOUS BUTTON 1 STATE
20 LET L2 = 0 : REM PREVIOUS BUTTON 2 STATE
21 LET C1 = 0 : REM CURRENT BUTTON 1 STATE
22 LET C2 = 0 : REM CURRENT BUTTON 2 STATE
23 LET KEY = 0 : REM KEYBOARD CODE
24 LET RDY = 6 : REM INITIALIZED AND READY BYTE

260 REM FIRST DETERMINE THE SLOT OF THE ESP32 SOFTCARD
270 PRINT CHR$(13) + "CHECKING SLOT: ";
280 FOR S = 0 TO 7
290 ADDR = (3080 + S) * 16
300 PRINT STR$(S) + "  ";
310 VID = PEEK(ADDR + 1)
320 IF VID = VAPPLE OR VID = VESP32 THEN SLOT = S : P0ARD = ADDR
330 NEXT S
343 PRINT CHR$(13)
350 IF P0ARD = 0 THEN PRINT "ESP32 CARD NOT FOUND" : END
360 P1ARD = P0ADR + 1 : REM PORT1 ADDRESS
370 PRINT "ESP32 SOFTCARD FOUND IN SLOT " + STR$(SLOT)
380 PRINT "PLEASE PLUG THE MONITOR THROUGH THE CARD"
390 FOR S = 0 TO 1000 : NEXT S
400 POKE P0ARD, RDY : REM SEND READY TO THE CARD

420 REM MAIN LOOP
430 VID = PEEK(P1ARD)
440 IF VID = VAPPLE AND CANEXIT = 1 THEN HOME : END
450 KEY = PEEK(49152)
460 IF KEY > 127 THEN GET DUMMY$ : POKE P0ARD, KB : POKE P0ARD, KEY : CANEXIT = 1
470 XCURRENT = PDL(0)
480 IF XCURRENT <> XLAST THEN POKE P0ARD, JX : POKE P0ARD, XCURRENT : XLAST = XCURRENT
490 C1 = PEEK(49249)
500 IF C1 <> L1 THEN POKE P0ARD, B1 : POKE P0ARD, C1 : L1 = C1
510 C2 = PEEK(49250)
520 IF C2 <> L2 THEN POKE P0ARD, B2 : POKE P0ARD, C2 : L2 = C2
530 YCURRENT = PDL(1)
540 IF YCURRENT <> YLAST THEN POKE P0ARD, JY : POKE P0ARD, YCURRENT : YLAST = YCURRENT
550 GOTO 430
